Bug 577711 - (CVE-2010-1188) CVE-2010-1188 kernel: ipv6: skb is unexpectedly freed
CVE-2010-1188 kernel: ipv6: skb is unexpectedly freed
Status: NEW
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
impact=important,reported=20100329,pu...
: Security
Depends On: 546402 577712 577713 577715 577716 577717 577718
Blocks:
  Show dependency treegraph
 
Reported: 2010-03-28 23:29 EDT by Eugene Teo (Security Response)
Modified: 2015-07-31 07:52 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Eugene Teo (Security Response) 2010-03-28 23:29:49 EDT
Description of problem:
The server side sets IPV6_RECVPKTINFO on a listening socket, and the client side just sends a message to the server.  Then the kernel panic occurs on the server.
    
This problem happens because a skb is forcibly freed in tcp_rcv_state_process().
    
When a socket in listening state(TCP_LISTEN) receives a syn packet, then tcp_v6_conn_request() will be called from tcp_rcv_state_process().  If the tcp_v6_conn_request() successfully returns, the skb would be discarded by __kfree_skb().
    
However, in case of a listening socket which was already set IPV6_RECVPKTINFO, an address of the skb will be stored in treq->pktopts and a ref count of the skb will be incremented in tcp_v6_conn_request().  But, even if the skb is still in use, the skb will be freed.  Then someone still using the freed skb will cause the kernel panic.

Upstream commit:
http://git.kernel.org/linus/fb7e2399ec17f1004c0e0ccfd17439f8759ede01
Comment 3 Kirk Larsen 2010-04-08 20:37:29 EDT
Hi,

Does this affect RHEL 5?

Thanks!
Comment 4 Guil Barros 2010-04-13 09:52:24 EDT
Does disabling ipv6 mitigate this vulnerability?
Comment 5 Eugene Teo (Security Response) 2010-04-13 21:39:58 EDT
(In reply to comment #3)
> Hi,
> 
> Does this affect RHEL 5?

Hi Kirk,

We have released an update for Red Hat Enterprise Linux 5. https://rhn.redhat.com/errata/RHSA-2010-0178.html.

Thanks, Eugene
Comment 6 Eugene Teo (Security Response) 2010-04-13 21:40:26 EDT
(In reply to comment #4)
> Does disabling ipv6 mitigate this vulnerability?    

Yes.
Comment 7 errata-xmlrpc 2010-04-27 08:46:07 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5.4.Z - Server Only

Via RHSA-2010:0380 https://rhn.redhat.com/errata/RHSA-2010-0380.html
Comment 8 errata-xmlrpc 2010-05-05 09:05:16 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4

Via RHSA-2010:0394 https://rhn.redhat.com/errata/RHSA-2010-0394.html
Comment 9 errata-xmlrpc 2010-05-18 18:06:19 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4.7 Z Stream

Via RHSA-2010:0424 https://rhn.redhat.com/errata/RHSA-2010-0424.html
Comment 10 errata-xmlrpc 2010-05-25 11:30:03 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5.3.Z - Server Only

Via RHSA-2010:0439 https://rhn.redhat.com/errata/RHSA-2010-0439.html
Comment 12 errata-xmlrpc 2010-11-12 04:37:21 EST
This issue has been addressed in following products:

  Red Hat Enterprise Linux 3 Extended Lifecycle Support

Via RHSA-2010:0882 https://rhn.redhat.com/errata/RHSA-2010-0882.html

Note You need to log in before you can comment on or make changes to this bug.